package finance.chai.chai_webview_plugin;

import androidx.annotation.Nullable;

import org.json.JSONObject;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;

public class WebviewBuildParams implements Serializable {
    boolean hidden;
    String url;
    String userAgent;
    boolean withJavascript;
    boolean clearCache;
    boolean clearCookies;
    boolean withZoom;
    boolean withLocalStorage;
    boolean supportMultipleWindows;
    boolean appCacheEnabled;
    Map<String, String> headers;
    boolean scrollBar;
    boolean allowFileURLs;
    boolean useWideViewPort;
    String invalidUrlRegex;
    boolean geolocationEnabled;
    Map<String, String> authCookies;

    static WebviewBuildParams newIsntance(MethodCall call){
        WebviewBuildParams params = new WebviewBuildParams();
        boolean hidden = call.argument("hidden");
        String url = call.argument("url");
        String userAgent = call.argument("userAgent");
        boolean withJavascript = call.argument("withJavascript");
        boolean clearCache = call.argument("clearCache");
        boolean clearCookies = call.argument("clearCookies");
        boolean withZoom = call.argument("withZoom");
        boolean withLocalStorage = call.argument("withLocalStorage");
        boolean supportMultipleWindows = call.argument("supportMultipleWindows");
        boolean appCacheEnabled = call.argument("appCacheEnabled");
        Map<String, String> headers = call.argument("headers");
        boolean scrollBar = call.argument("scrollBar");
        boolean allowFileURLs = call.argument("allowFileURLs");
        boolean useWideViewPort = call.argument("useWideViewPort");
        String invalidUrlRegex = call.argument("invalidUrlRegex");
        boolean geolocationEnabled = call.argument("geolocationEnabled");
        HashMap authCookies = call.argument("authCookies");
        params.hidden = hidden;
        params.url = url;
        params.userAgent = userAgent;
        params.withJavascript = withJavascript;
        params.clearCache = clearCache;
        params.clearCookies = clearCookies;
        params.withZoom = withZoom;
        params.withLocalStorage = withLocalStorage;
        params.supportMultipleWindows = supportMultipleWindows;
        params.appCacheEnabled = appCacheEnabled;
        params.headers= headers;
        params.scrollBar= scrollBar;
        params.allowFileURLs= allowFileURLs;
        params.useWideViewPort= useWideViewPort;
        params.invalidUrlRegex= invalidUrlRegex;
        params.geolocationEnabled= geolocationEnabled;
        params.authCookies= authCookies;
        return params;
    }

}
